]> git.ipfire.org Git - thirdparty/git.git/blob - git-sh-setup.sh
Handle format.subjectprefix for every command which accepts --pretty
[thirdparty/git.git] / git-sh-setup.sh
1 #!/bin/sh
2 #
3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
6 # it dies.
7
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be be taken to unexpected places. If you
10 # like CDPATH, define it for your interactive shell sessions without
11 # exporting it.
12 unset CDPATH
13
14 die() {
15 echo >&2 "$@"
16 exit 1
17 }
18
19 usage() {
20 die "Usage: $0 $USAGE"
21 }
22
23 set_reflog_action() {
24 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
25 then
26 GIT_REFLOG_ACTION="$*"
27 export GIT_REFLOG_ACTION
28 fi
29 }
30
31 is_bare_repository () {
32 git rev-parse --is-bare-repository
33 }
34
35 cd_to_toplevel () {
36 cdup=$(git rev-parse --show-cdup)
37 if test ! -z "$cdup"
38 then
39 cd "$cdup" || {
40 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
41 exit 1
42 }
43 fi
44 }
45
46 require_work_tree () {
47 test $(git rev-parse --is-inside-work-tree) = true &&
48 test $(git rev-parse --is-inside-git-dir) = false ||
49 die "fatal: $0 cannot be used without a working tree."
50 }
51
52 get_author_ident_from_commit () {
53 pick_author_script='
54 /^author /{
55 s/'\''/'\''\\'\'\''/g
56 h
57 s/^author \([^<]*\) <[^>]*> .*$/\1/
58 s/'\''/'\''\'\'\''/g
59 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
60
61 g
62 s/^author [^<]* <\([^>]*\)> .*$/\1/
63 s/'\''/'\''\'\'\''/g
64 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
65
66 g
67 s/^author [^<]* <[^>]*> \(.*\)$/\1/
68 s/'\''/'\''\'\'\''/g
69 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
70
71 q
72 }
73 '
74 encoding=$(git config i18n.commitencoding || echo UTF-8)
75 git show -s --pretty=raw --encoding="$encoding" "$1" |
76 LANG=C LC_ALL=C sed -ne "$pick_author_script"
77 }
78
79 if [ -z "$LONG_USAGE" ]
80 then
81 LONG_USAGE="Usage: $0 $USAGE"
82 else
83 LONG_USAGE="Usage: $0 $USAGE
84
85 $LONG_USAGE"
86 fi
87
88 case "$1" in
89 -h|--h|--he|--hel|--help)
90 echo "$LONG_USAGE"
91 exit
92 esac
93
94 # Make sure we are in a valid repository of a vintage we understand.
95 if [ -z "$SUBDIRECTORY_OK" ]
96 then
97 : ${GIT_DIR=.git}
98 GIT_DIR=$(GIT_DIR="$GIT_DIR" git rev-parse --git-dir) || {
99 exit=$?
100 echo >&2 "You need to run this command from the toplevel of the working tree."
101 exit $exit
102 }
103 else
104 GIT_DIR=$(git rev-parse --git-dir) || exit
105 fi
106 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}